commit 7c3507f63bf19a409d1ffe85b3415d9813fe4435
Author: Marc Dequènes (Duck) <Duck@DuckCorp.org>
Date:   Tue Sep 7 00:59:42 2010 +0200

    [evol] preliminary support for OpenLDAP 'cn=config' world §3 (translations) (refs #143)

diff --git a/conf/ldap_shadows/worlds/OpenLDAP_config/shadows/Administration/translations/em.yml b/conf/ldap_shadows/worlds/OpenLDAP_config/shadows/Administration/translations/em.yml
new file mode 100644
index 0000000..88e5f69
--- /dev/null
+++ b/conf/ldap_shadows/worlds/OpenLDAP_config/shadows/Administration/translations/em.yml
@@ -0,0 +1,127 @@
+---
+en:
+  objects:
+    global: "LDAP Server"
+    database: "LDAP Database"
+    schema: "LDAP Schema"
+  attribute_types:
+    cn: "Full Name"
+    createTimestamp: "Item creation time"
+    creatorsName: "Item Creator"
+    description: "Description"
+    entryUUID: "Item UUID"
+    modifiersName: "Item Last Modifier"
+    modifyTimestamp: "Item Last Modification Time"
+    olcAccess: "Security Access Control"
+    olcAddContentAcl: "Security Check on Content for Add Operation"
+    olcAllows: "LDAP Features to Allow"
+    olcArgsFile: "Server Arguments File"
+    olcAttributeOptions: "Server Tagging Attribute Options"
+    olcAttributeTypes: "LDAP Attribute Type Definition"
+    olcAuthzPolicy: "Security Authorization Proxy Rules"
+    olcAuthzRegexp: "Security Authentication User Mapping"
+    olcConcurrency: "Server (Thread) Concurrency Level"
+    olcConfigDir: "Configuration Directory"
+    olcConfigFile: "Configuration File (fallback)"
+    olcConnMaxPending: "Connection Maximum Pending Requests for Anonymous Sessions"
+    olcConnMaxPendingAuth: "Connection Maximum Pending Requests for Authenticated Sessions"
+    olcDatabase: "Database Name"
+    olcDbCacheFree: "Database Cache to Free when Full (entries number)"
+    olcDbCacheSize: "Database Cache Size (entries number)"
+    olcDbCheckpoint: "Database Checkpoint interval"
+    olcDbCryptKey: "Database Encryption Key"
+    olcDbCryptFile: "Database Encryption Key File"
+    olcDbConfig: "Database BDB Configuration"
+    olcDbDirtyRead: "Database Allow Dirty Reads (uncommitted data)"
+    olcDbDirectory: "Database Directory"
+    olcDbDNcacheSize: "Database DN Cache Size"
+    olcDbIDLcacheSize: "Database IDL Cache Size"
+    olcDbIndex: "Database Index(es)"
+    olcDbLinearIndex: "Database Indexes Processed Individually"
+    olcDbLockDetect: "Database Deadlock Detection Algorithm"
+    olcDbMode: "Database Files UNIX Permissions"
+    olcDbNoSync: "Database No Synchronous Writes"
+    olcDbPageSize: "Database Page Size (kB)"
+    olcDbSearchStack: "Database Search Stack Depth"
+    olcDbShmKey: "Database SHM Key"
+    olcDefaultSearchBase: "LDAP Default Search Base DN"
+    olcDitContentRules: "LDAP DIT Content Rules Definition"
+    olcDisallows: "LDAP Features to Disallow"
+    olcDlAttrSet: "Overlay DynamicList Definition"
+    olcGentleHUP: "Server SIGHUP as graceful shutdown"
+    olcHidden: "Database Hidden"
+    olcIdleTimeout: "Client Idle Timeout (s)"
+    olcIndexIntLen: "Index Key Length for Ordered Integer Indices"
+    olcIndexSubstrIfMaxLen: "Index Maximum Length for Subinitial and Subfinal Indices"
+    olcIndexSubstrIfMinLen: "Index Minimum Length for Subinitial and Subfinal Indices"
+    olcIndexSubstrAnyLen: "Index length used for subany indices"
+    olcIndexSubstrAnyStep: "Index steps used in subany index lookups"
+    olcLastMod: "LDAP Maintain User and Timestamp Operations Information"
+    olcLdapSyntaxes: "LDAP Syntax Definition"
+    olcLimits: "Limit Time and Size for Operations"
+    olcLocalSSF: "Security SSF for Local Sessions (like ldapi)"
+    olcLogFile: "Log File"
+    olcLogLevel: "Log Selected Categories"
+    olcMaxDerefDepth: "Limit Aliases Dereferenciation"
+    olcMirrorMode: "Replication Mirror Mode"
+    olcModuleLoad: "Dynamically Loadable Module"
+    olcModulePath: "Path for Modules"
+    olcMonitoring: "Overlay Monitor Activated on Database"
+    olcObjectClasses: "LDAP Object Class Definition"
+    olcObjectIdentifier: "LDAP Object Identifier Definition"
+    olcOverlay: "OpenLDAP Overlay Name"
+    olcPasswordCryptSaltFormat: "Salt Format for CRYPT passwords"
+    olcPasswordHash: "LDAP Password Hashes (Password Modify Extended Operation)"
+    olcPidFile: "Server PID File"
+    olcPlugin: "Server SLAPI Plugin configuration"
+    olcPluginLogFile: "Log File for Plugins"
+    olcReadOnly: "Database Read Only"
+    olcReferral: "LDAP Global Fallback Referal"
+    olcRequires: "Security Level for Operations"
+    olcRestrict: "Security Restricted Operations"
+    olcReverseLookup: "Client Name Unverified Reverse Lookup"
+    olcRootDN: "LDAP Database Root DN"
+    olcRootDSE: "LDAP Custom Root DSE Attributes File"
+    olcRootPW: "LDAP Database Root Password"
+    olcSaslHost: "SASL Server FQDN"
+    olcSaslRealm: "SASL Realm"
+    olcSaslSecProps: "SASL Security Properties"
+    olcSchemaDN: "LDAP Schema Definition DN"
+    olcSecurity: "Security Required SSF List"
+    olcServerID: "Replication Server ID"
+    olcSizeLimit: "Limit Maximum Search Result Size (entries number)"
+    olcSockbufMaxIncoming: "Connection Maximum Incoming PDU Size for Anonymous Sessions"
+    olcSockbufMaxIncomingAuth: "Connection Maximum Incoming PDU Size for Authenticated Sessions"
+    olcSortVals: "LDAP Always Sorted Multi-Valued Attributes"
+    olcSpCheckpoint: "Replication Provider Checkpoint Interval"
+    olcSpNoPresent: "Replication Provider Omit Present Phase Processing"
+    olcSpReloadHint: "Replication Provider Observe Reload Hint in Request Control"
+    olcSpSessionlog: "Replication Provider Session Log Size"
+    olcSubordinate: "LDAP Database Subordinate"
+    olcSuffix: "LDAP Database DN Suffix"
+    olcSyncrepl: "Replication Replica Configuration"
+    olcSyncUseSubentry: "Replication Store contextCSN in Special Subentry"
+    olcThreads: "Server Primary Thread Pool Maximum Size"
+    olcTimeLimit: "LDAP Maximum Search Time (s)"
+    olcToolThreads: "Server Tool Thread Pool Maximum Size"
+    olcTLSCACertificateFile: "TLS CA Certificates File"
+    olcTLSCACertificatePath: "TLS CA Certificates Path"
+    olcTLSCertificateFile: "TLS Server Public Certificate File"
+    olcTLSCertificateKeyFile: "TLS Server Private Certificate File"
+    olcTLSCipherSuite: "TLS Accepted Ciphers"
+    olcTLSCRLCheck: "TLS CRL Check Level"
+    olcTLSCRLFile: "TLS CRL File"
+    olcTLSDHParamFile: "TLS DH Parameters File"
+    olcTLSRandFile: "TLS Random Source File"
+    olcTLSVerifyClient: "TLS Verify Client Certificate"
+    olcUniqueAttribute: "Overlay Unique Attributes"
+    olcUniqueBase: "Overlay Unique Base DN"
+    olcUniqueIgnore: "Overlay Unique Ignored Attributes"
+    olcUniqueStrict: "Overlay Unique Null Values"
+    olcUniqueURI: "Overlay Unique URI(s)"
+    olcUpdateDN: "Replication Replica Update DN"
+    olcUpdateRef: "Replication Replica Modify Referral"
+    olcWriteTimeout: "Connection Write Timeout (s)"
+  relations:
+  aspects:
+