commit 7527ece5163c46977dd23196eef6cba48cac256c
Author: Marc Dequènes (Duck) <Duck@DuckCorp.org>
Date:   Wed Jan 8 00:09:01 2014 +0100

    [translation] update POT and fr PO

diff --git a/po/cyborghood.pot b/po/cyborghood.pot
index 09081b4..bad5d90 100644
--- a/po/cyborghood.pot
+++ b/po/cyborghood.pot
@@ -1,105 +1,128 @@
 # SOME DESCRIPTIVE TITLE.
 # Copyright (C) YEAR THE PACKAGE'S COPYRIGHT HOLDER
-# This file is distributed under the same license as the PACKAGE package.
+# This file is distributed under the same license as the CyborgHood package.
 # FIRST AUTHOR <EMAIL@ADDRESS>, YEAR.
 #
 #, fuzzy
 msgid ""
 msgstr ""
-"Project-Id-Version: CyborgHood 0.2.0~dev\n"
+"Project-Id-Version: CyborgHood 0.3.0\n"
+"Report-Msgid-Bugs-To: \n"
 "POT-Creation-Date: 2010-04-04 17:37+0200\n"
-"PO-Revision-Date: 2009-03-07 21:38+0100\n"
+"PO-Revision-Date: 2014-01-07 23:40+0100\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
 "Language-Team: LANGUAGE <LL@li.org>\n"
+"Language: \n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=INTEGER; plural=EXPRESSION;\n"
 
-#: lib/cyborghood/order.rb:57
-msgid "Syntax error in command."
+#: ../lib/cyborghood/mail_order.rb:61
+msgid "Attachment '%{ref}' not found."
 msgstr ""
 
-#: lib/cyborghood/mail.rb:92
-msgid "Replay detected."
+#: ../lib/cyborghood/command_runner.rb:176
+msgid "Command not recognized."
 msgstr ""
 
-#: lib/cyborghood/mail.rb:98
-msgid "Mail not RFC3156 compliant."
+#: ../lib/cyborghood/mail.rb:126
+msgid "Contact URL:"
 msgstr ""
 
-#: lib/cyborghood/mail.rb:172
-msgid "Mail not formatted correctly (signed part)."
+#: ../lib/cyborghood/mail.rb:125
+msgid "Contact eMail:"
+msgstr ""
+
+#: ../lib/cyborghood/mail.rb:179
+msgid "Could not get public key for '%{fpr}'"
+msgstr ""
+
+#: ../lib/cyborghood/command_runner.rb:47
+#: ../lib/cyborghood/command_runner.rb:162
+msgid "Internal error. Administrator is warned."
 msgstr ""
 
-#: lib/cyborghood/mail.rb:175
+#: ../lib/cyborghood/command_runner.rb:140
+msgid "Invalid zone data."
+msgstr ""
+
+#: ../lib/cyborghood/mail.rb:173
 msgid "Mail content tampered or badly signed: %{sig_err}"
 msgstr ""
 
-#: lib/cyborghood/mail.rb:179
+#: ../lib/cyborghood/mail_order.rb:45
+msgid "Mail does not contain a proper text part for commands."
+msgstr ""
+
+#: ../lib/cyborghood/mail.rb:181
 msgid "Mail is from an unknown person."
 msgstr ""
 
-#: lib/cyborghood/mail.rb:188
-msgid ""
-"The signature was made too long ago (check your system clock). Rejected "
-"message to avoid replay attacks."
+#: ../lib/cyborghood/mail.rb:97
+msgid "Mail not RFC3156 compliant."
 msgstr ""
 
-#: lib/cyborghood/mail.rb:192
+#: ../lib/cyborghood/mail.rb:245
 msgid ""
-"The signature was made in the future (check your system clock). Rejected "
-"message to avoid replay attacks."
+"Mail not formatted correctly (encrypted part), or not encrypted with the corre"
+"ct key."
 msgstr ""
 
-#: lib/cyborghood/mail.rb:237
-msgid "Mail not formatted correctly (encrypted part)."
+#: ../lib/cyborghood/mail.rb:170
+msgid "Mail not formatted correctly (signed part)."
 msgstr ""
 
-#: lib/cyborghood/mail_order.rb:25
-msgid "Mail does not contain a proper text part for commands."
+#: ../lib/cyborghood/command_runner.rb:119
+msgid "No attachment number provided"
 msgstr ""
 
-#: lib/cyborghood/mail_order.rb:38
-msgid "Attachment '%{ref}' not found."
+#: ../lib/cyborghood/mail.rb:90
+msgid "Replay detected."
 msgstr ""
 
-#: lib/cyborghood/command_runner.rb:47 lib/cyborghood/command_runner.rb:157
-msgid "Internal error. Administrator is warned."
+#: ../lib/cyborghood/command_runner.rb:97
+msgid "Requested zone content attached."
 msgstr ""
 
-#: lib/cyborghood/command_runner.rb:75
-msgid "You are manager of the following zones: %{zone_list}."
+#: ../lib/cyborghood/order.rb:93
+msgid "Syntax error in command."
 msgstr ""
 
-#: lib/cyborghood/command_runner.rb:85 lib/cyborghood/command_runner.rb:107
-msgid "This zone is not hosted here."
+#: ../lib/cyborghood/mail.rb:194
+msgid ""
+"The signature was made in the future (check your system clock). Rejected messa"
+"ge to avoid replay attacks."
 msgstr ""
 
-#: lib/cyborghood/command_runner.rb:89 lib/cyborghood/command_runner.rb:111
-msgid "You are not allowed to manage this zone."
+#: ../lib/cyborghood/mail.rb:190
+msgid ""
+"The signature was made too long ago (check your system clock). Rejected messag"
+"e to avoid replay attacks."
 msgstr ""
 
-#: lib/cyborghood/command_runner.rb:95
-msgid "Requested zone content attached."
+#: ../lib/cyborghood/command_runner.rb:85
+#: ../lib/cyborghood/command_runner.rb:109
+msgid "This zone is not hosted here."
 msgstr ""
 
-#: lib/cyborghood/command_runner.rb:120
-msgid "Attachment has wrong content-type."
+#: ../lib/cyborghood/command_runner.rb:75
+msgid "You are manager of the following zones: %{zone_list}."
 msgstr ""
 
-#: lib/cyborghood/command_runner.rb:135
-msgid "Invalid zone data."
+#: ../lib/cyborghood/command_runner.rb:89
+#: ../lib/cyborghood/command_runner.rb:113
+msgid "You are not allowed to manage this zone."
 msgstr ""
 
-#: lib/cyborghood/command_runner.rb:142
-msgid "Zone serial is not superior to current serial."
+#: ../lib/cyborghood/command_runner.rb:125
+msgid "Zone data has wrong content-type."
 msgstr ""
 
-#: lib/cyborghood/command_runner.rb:153
-msgid "Zone updated."
+#: ../lib/cyborghood/command_runner.rb:147
+msgid "Zone serial is not superior to current serial."
 msgstr ""
 
-#: lib/cyborghood/command_runner.rb:171
-msgid "Command not recognized."
+#: ../lib/cyborghood/command_runner.rb:158
+msgid "Zone updated."
 msgstr ""
diff --git a/po/cyborghood_postman.pot b/po/cyborghood_postman.pot
index bf90eaf..3cdbaf0 100644
--- a/po/cyborghood_postman.pot
+++ b/po/cyborghood_postman.pot
@@ -1,49 +1,43 @@
 # SOME DESCRIPTIVE TITLE.
 # Copyright (C) YEAR THE PACKAGE'S COPYRIGHT HOLDER
-# This file is distributed under the same license as the PACKAGE package.
+# This file is distributed under the same license as the CyborgHood package.
 # FIRST AUTHOR <EMAIL@ADDRESS>, YEAR.
 #
 #, fuzzy
 msgid ""
 msgstr ""
-"Project-Id-Version: CyborgHood 0.2.0~dev\n"
+"Project-Id-Version: CyborgHood 0.3.0\n"
+"Report-Msgid-Bugs-To: \n"
 "POT-Creation-Date: 2010-04-04 17:37+0200\n"
-"PO-Revision-Date: 2009-03-07 21:38+0100\n"
+"PO-Revision-Date: 2014-01-07 23:40+0100\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
 "Language-Team: LANGUAGE <LL@li.org>\n"
+"Language: \n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=INTEGER; plural=EXPRESSION;\n"
 
-#: /opt/cyborghood-dev/bin/postman:145 /opt/cyborghood-dev/bin/postman:161
-msgid "Hello %{cn},"
-msgstr ""
-
-#: /opt/cyborghood-dev/bin/postman:145
-msgid "Hello,"
-msgstr ""
-
-#: /opt/cyborghood-dev/bin/postman:147
+#: ../bin/postman:168
 msgid ""
-"A message (ID: %{id}), apparently from you, was rejected for the following "
-"reason:"
+"A message (ID: %{id}), apparently from you, was rejected for the following rea"
+"son:"
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:166
+#: ../bin/postman:188
 msgid ""
-"An order, in a message (ID: %{id}) from you, was rejected for the following "
-"reason:"
+"An order, in a message (ID: %{id}) from you, was rejected for the following re"
+"ason:"
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:180
+#: ../bin/postman:201
 msgid "Follows the transcript of your commands:"
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:229
-msgid "Contact eMail:"
+#: ../bin/postman:166 ../bin/postman:183
+msgid "Hello %{cn},"
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:230
-msgid "Contact URL:"
+#: ../bin/postman:166
+msgid "Hello,"
 msgstr ""
diff --git a/po/fr/cyborghood.po b/po/fr/cyborghood.po
index 8387b0f..3bdad58 100644
--- a/po/fr/cyborghood.po
+++ b/po/fr/cyborghood.po
@@ -1,109 +1,130 @@
 # CyborgHood
-# Copyright (C) 2009-2010 DuckCorp
+# Copyright (C) 2009-2014 DuckCorp
 # This file is distributed under the same license as the CyborgHood package.
-# Marc Dequènes (Duck) <Duck@DuckCorp.org>, 2009-2010.
+# Marc Dequènes (Duck) <Duck@DuckCorp.org>, 2009-2014.
 #
-#, fuzzy
 msgid ""
 msgstr ""
 "Project-Id-Version: CyborgHood 0.2.0~dev\n"
 "POT-Creation-Date: 2010-04-04 17:37+0200\n"
-"PO-Revision-Date: 2010-04-04 20:59+0100\n"
+"PO-Revision-Date: 2014-01-08 00:01+0100\n"
 "Last-Translator: Marc Dequènes (Duck) <Duck@DuckCorp.org>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=2; plural=(n > 1);\n"
 
-#: lib/cyborghood/order.rb:57
-msgid "Syntax error in command."
-msgstr "Erreur de syntaxe dans la commande."
+#: ../lib/cyborghood/mail_order.rb:61
+msgid "Attachment '%{ref}' not found."
+msgstr "La pièce jointe '%{ref}' n'a pas été trouvée."
 
-#: lib/cyborghood/mail.rb:92
-msgid "Replay detected."
-msgstr "Rejeu détecté."
+#: ../lib/cyborghood/command_runner.rb:176
+msgid "Command not recognized."
+msgstr "Commande non reconnue."
 
-#: lib/cyborghood/mail.rb:98
-msgid "Mail not RFC3156 compliant."
-msgstr "Mail ne respectant pas la RFC3156."
+#: ../lib/cyborghood/mail.rb:126
+msgid "Contact URL:"
+msgstr "URL de contact :"
 
-#: lib/cyborghood/mail.rb:172
-msgid "Mail not formatted correctly (signed part)."
-msgstr "Mail formaté incorrectement (partie signée)."
+#: ../lib/cyborghood/mail.rb:125
+msgid "Contact eMail:"
+msgstr "Email de contact :"
+
+#: ../lib/cyborghood/mail.rb:179
+msgid "Could not get public key for '%{fpr}'"
+msgstr "Impossible d'obtenir la clef publique de '%{fpr}'"
+
+#: ../lib/cyborghood/command_runner.rb:47
+#: ../lib/cyborghood/command_runner.rb:162
+msgid "Internal error. Administrator is warned."
+msgstr "Erreur interne. L'administrateur a été prévenu."
+
+#: ../lib/cyborghood/command_runner.rb:140
+msgid "Invalid zone data."
+msgstr "Données pour la zone invalides."
 
-#: lib/cyborghood/mail.rb:175
+#: ../lib/cyborghood/mail.rb:173
 msgid "Mail content tampered or badly signed: %{sig_err}"
 msgstr "Contenu du mail altéré ou mal signé: %{sig_err}"
 
-#: lib/cyborghood/mail.rb:179
+#: ../lib/cyborghood/mail_order.rb:45
+msgid "Mail does not contain a proper text part for commands."
+msgstr "Le mail ne contient pas de partie textuelle correcte pour les commandes."
+
+#: ../lib/cyborghood/mail.rb:181
 msgid "Mail is from an unknown person."
 msgstr "Mail provenant d'une personne inconnue"
 
-#: lib/cyborghood/mail.rb:188
-msgid ""
-"The signature was made too long ago (check your system clock). Rejected "
-"message to avoid replay attacks."
-msgstr ""
-"La signature a été faite depuis trop longtemps (vérifiez votre horloge "
-"système. Message rejeté pour éviter les attaques par rejeux."
+#: ../lib/cyborghood/mail.rb:97
+msgid "Mail not RFC3156 compliant."
+msgstr "Mail ne respectant pas la RFC3156."
 
-#: lib/cyborghood/mail.rb:192
+#: ../lib/cyborghood/mail.rb:245
 msgid ""
-"The signature was made in the future (check your system clock). Rejected "
-"message to avoid replay attacks."
-msgstr ""
-"La signature a été faite dans le futur (vérifiez votre horloge système. "
-"Message rejeté pour éviter les attaques par rejeux."
+"Mail not formatted correctly (encrypted part), or not encrypted with the corre"
+"ct key."
+msgstr "Mail formaté incorrectement (partie chiffrée), ou non chiffré avec la"
+"bonne clef."
 
-#: lib/cyborghood/mail.rb:237
-msgid "Mail not formatted correctly (encrypted part)."
-msgstr "Mail formaté incorrectement (partie chiffrée)."
+#: ../lib/cyborghood/mail.rb:170
+msgid "Mail not formatted correctly (signed part)."
+msgstr "Mail formaté incorrectement (partie signée)."
 
-#: lib/cyborghood/mail_order.rb:25
-msgid "Mail does not contain a proper text part for commands."
-msgstr ""
-"Le mail ne contient pas de partie textuelle correcte pour les commandes."
+#: ../lib/cyborghood/command_runner.rb:119
+msgid "No attachment number provided"
+msgstr "Aucun numéro de pièce attachée fournie"
 
-#: lib/cyborghood/mail_order.rb:38
-msgid "Attachment '%{ref}' not found."
-msgstr "La pièce jointe '%{ref}' n'a pas été trouvée."
+#: ../lib/cyborghood/mail.rb:90
+msgid "Replay detected."
+msgstr "Rejeu détecté."
 
-#: lib/cyborghood/command_runner.rb:47 lib/cyborghood/command_runner.rb:157
-msgid "Internal error. Administrator is warned."
-msgstr "Erreur interne. L'administrateur a été prévenu."
+#: ../lib/cyborghood/command_runner.rb:97
+msgid "Requested zone content attached."
+msgstr "Le contenu de la zone demandée est en pièce jointe."
 
-#: lib/cyborghood/command_runner.rb:75
-msgid "You are manager of the following zones: %{zone_list}."
-msgstr "Vous gérez les zones suivantes : %{zone_list}."
+#: ../lib/cyborghood/order.rb:93
+msgid "Syntax error in command."
+msgstr "Erreur de syntaxe dans la commande."
+
+#: ../lib/cyborghood/mail.rb:194
+msgid ""
+"The signature was made in the future (check your system clock). Rejected messa"
+"ge to avoid replay attacks."
+msgstr ""
+"La signature a été faite dans le futur (vérifiez votre horloge système. Messag"
+"e rejeté pour éviter les attaques par rejeux."
 
-#: lib/cyborghood/command_runner.rb:85 lib/cyborghood/command_runner.rb:107
+#: ../lib/cyborghood/mail.rb:190
+msgid ""
+"The signature was made too long ago (check your system clock). Rejected messag"
+"e to avoid replay attacks."
+msgstr ""
+"La signature a été faite depuis trop longtemps (vérifiez votre horloge système"
+". Message rejeté pour éviter les attaques par rejeux."
+
+#: ../lib/cyborghood/command_runner.rb:85
+#: ../lib/cyborghood/command_runner.rb:109
 msgid "This zone is not hosted here."
 msgstr "Cette zone n'est pas hébergée ici."
 
-#: lib/cyborghood/command_runner.rb:89 lib/cyborghood/command_runner.rb:111
+#: ../lib/cyborghood/command_runner.rb:75
+msgid "You are manager of the following zones: %{zone_list}."
+msgstr "Vous gérez les zones suivantes : %{zone_list}."
+
+#: ../lib/cyborghood/command_runner.rb:89
+#: ../lib/cyborghood/command_runner.rb:113
 msgid "You are not allowed to manage this zone."
 msgstr "Vous n'êtes pas autorisé à gérer cette zone."
 
-#: lib/cyborghood/command_runner.rb:95
-msgid "Requested zone content attached."
-msgstr "Le contenu de la zone demandée est en pièce jointe."
-
-#: lib/cyborghood/command_runner.rb:120
-msgid "Attachment has wrong content-type."
-msgstr "La pièce jointe a un mauvais type de contenu (content-type)."
+#: ../lib/cyborghood/command_runner.rb:125
+msgid "Zone data has wrong content-type."
+msgstr "Les données de la zone ont un mauvais type de contenu (content-type)."
 
-#: lib/cyborghood/command_runner.rb:135
-msgid "Invalid zone data."
-msgstr "Données pour la zone invalides."
-
-#: lib/cyborghood/command_runner.rb:142
+#: ../lib/cyborghood/command_runner.rb:147
 msgid "Zone serial is not superior to current serial."
 msgstr "Le numéro de série de la zone n'est pas supèrieur à celui actuel."
 
-#: lib/cyborghood/command_runner.rb:153
+#: ../lib/cyborghood/command_runner.rb:158
 msgid "Zone updated."
 msgstr "Zone mise à jour."
 
-#: lib/cyborghood/command_runner.rb:171
-msgid "Command not recognized."
-msgstr "Commande non reconnue."
diff --git a/po/fr/cyborghood_postman.po b/po/fr/cyborghood_postman.po
index 2570186..9135295 100644
--- a/po/fr/cyborghood_postman.po
+++ b/po/fr/cyborghood_postman.po
@@ -1,52 +1,44 @@
 # CyborgHood
-# Copyright (C) 2009-2010 DuckCorp
+# Copyright (C) 2009-2014 DuckCorp
 # This file is distributed under the same license as the CyborgHood package.
-# Marc Dequènes (Duck) <Duck@DuckCorp.org>, 2009-2010.
+# Marc Dequènes (Duck) <Duck@DuckCorp.org>, 2009-2014.
 #
-#, fuzzy
 msgid ""
 msgstr ""
 "Project-Id-Version: CyborgHood 0.2.0~dev\n"
 "POT-Creation-Date: 2010-04-04 17:37+0200\n"
-"PO-Revision-Date: 2010-04-04 21:27+0100\n"
+"PO-Revision-Date: 2014-01-08 00:01+0100\n"
 "Last-Translator: Marc Dequènes (Duck) <Duck@DuckCorp.org>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=2; plural=(n > 1);\n"
 
-#: /opt/cyborghood-dev/bin/postman:145 /opt/cyborghood-dev/bin/postman:161
-msgid "Hello %{cn},"
-msgstr "Bonjour %{cn},"
-
-#: /opt/cyborghood-dev/bin/postman:145
-msgid "Hello,"
-msgstr "Bonjour,"
-
-#: /opt/cyborghood-dev/bin/postman:147
+#: ../bin/postman:168
 msgid ""
-"A message (ID: %{id}), apparently from you, was rejected for the following "
-"reason:"
+"A message (ID: %{id}), apparently from you, was rejected for the following rea"
+"son:"
 msgstr ""
-"Un message (ID: %{id}), provenant apparemment de vous, a été rejeté pour la "
-"raison suivante :"
+"Un message (ID: %{id}), provenant apparemment de vous, a été rejeté pour la ra"
+"ison suivante :"
 
-#: /opt/cyborghood-dev/bin/postman:166
+#: ../bin/postman:188
 msgid ""
-"An order, in a message (ID: %{id}) from you, was rejected for the following "
-"reason:"
+"An order, in a message (ID: %{id}) from you, was rejected for the following re"
+"ason:"
 msgstr ""
-"Un order, dans in message (ID: %{id}) venant de vous, a été rejeté pour la "
-"raison suivante :"
+"Un order, dans in message (ID: %{id}) venant de vous, a été rejeté pour la rai"
+"son suivante :"
 
-#: /opt/cyborghood-dev/bin/postman:180
+#: ../bin/postman:201
 msgid "Follows the transcript of your commands:"
 msgstr "La retranscription des commandes suit :"
 
-#: /opt/cyborghood-dev/bin/postman:229
-msgid "Contact eMail:"
-msgstr "eMail de Contact :"
+#: ../bin/postman:166 ../bin/postman:183
+msgid "Hello %{cn},"
+msgstr "Bonjour %{cn},"
+
+#: ../bin/postman:166
+msgid "Hello,"
+msgstr "Bonjour,"
 
-#: /opt/cyborghood-dev/bin/postman:230
-msgid "Contact URL:"
-msgstr "URL de Contact :"